diff -ruN gcc-15.1.0.orig/config/gthr.m4 gcc-15.1.0/config/gthr.m4
--- gcc-15.1.0.orig/config/gthr.m4	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/config/gthr.m4	2025-04-25 15:58:40.260619802 +0300
@@ -23,6 +23,7 @@
     vxworks)	thread_header=config/gthr-vxworks.h ;;
     win32)	thread_header=config/i386/gthr-win32.h ;;
     mcf)	thread_header=config/i386/gthr-mcf.h ;;
+    morphos)	thread_header=config/rs6000/gthr-morphos.h ;;
 esac
 AC_SUBST(thread_header)
 ])
diff -ruN gcc-15.1.0.orig/config.rpath gcc-15.1.0/config.rpath
--- gcc-15.1.0.orig/config.rpath	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/config.rpath	2025-04-25 15:58:40.260619802 +0300
@@ -159,6 +159,9 @@
         ld_shlibs=no
       fi
       ;;
+    morphos*)
+      ld_shlibs=no
+      ;;
     netbsd*)
       ;;
     solaris* | sysv5*)
diff -ruN gcc-15.1.0.orig/configure.ac gcc-15.1.0/configure.ac
--- gcc-15.1.0.orig/configure.ac	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/configure.ac	2025-04-25 15:58:40.264619834 +0300
@@ -1319,6 +1319,9 @@
   powerpc-*-beos*)
     noconfigdirs="$noconfigdirs gdb"
     ;;
+  powerpc-*-morphos)
+    noconfigdirs="$noconfigdirs gprof target-libgloss target-libssp ${libgcj}"
+    ;;
   rs6000-*-lynxos*)
     noconfigdirs="$noconfigdirs gprof"
     ;;
diff -ruN gcc-15.1.0.orig/c++tools/resolver.cc gcc-15.1.0/c++tools/resolver.cc
--- gcc-15.1.0.orig/c++tools/resolver.cc	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/c++tools/resolver.cc	2025-04-25 15:58:40.264619834 +0300
@@ -41,7 +41,7 @@
 #else
 #ifdef HAVE_SYS_MMAN_H
 #include <sys/mman.h>
-#define MAPPED_READING 1
+#define MAPPED_READING 0
 #else
 #define MAPPED_READING 0
 #endif
diff -ruN gcc-15.1.0.orig/c++tools/server.cc gcc-15.1.0/c++tools/server.cc
--- gcc-15.1.0.orig/c++tools/server.cc	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/c++tools/server.cc	2025-04-25 15:58:40.264619834 +0300
@@ -39,7 +39,7 @@
 // Network
 /* Include network stuff first.  Excitingly OSX10.14 uses bcmp here, which
    we poison later!  */
-#if defined (HAVE_AF_UNIX) || defined (HAVE_AF_INET6)
+#if !defined(__MORPHOS__) && (defined (HAVE_AF_UNIX) || defined (HAVE_AF_INET6))
 /* socket, bind, listen, accept{4}  */
 # define NETWORKING 1
 # include <sys/socket.h>
diff -ruN gcc-15.1.0.orig/fixincludes/configure.ac gcc-15.1.0/fixincludes/configure.ac
--- gcc-15.1.0.orig/fixincludes/configure.ac	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/fixincludes/configure.ac	2025-04-25 15:58:40.264619834 +0300
@@ -53,6 +53,7 @@
 	i?86-*-mingw32* | \
 	x86_64-*-mingw32* | \
 	*-*-beos* | \
+	*-*-morphos* | \
         *-*-*vms*)
 		TARGET=twoprocess
 		;;
diff -ruN gcc-15.1.0.orig/fixincludes/fixlib.h gcc-15.1.0/fixincludes/fixlib.h
--- gcc-15.1.0.orig/fixincludes/fixlib.h	2025-04-25 11:17:59.000000000 +0300
+++ gcc-15.1.0/fixincludes/fixlib.h	2025-04-25 15:58:40.264619834 +0300
@@ -32,6 +32,10 @@
 #include "xregex.h"
 #include "libiberty.h"
 
+#ifdef __MORPHOS__
+#define fork vfork
+#endif
+
 #ifndef STDIN_FILENO
 # define STDIN_FILENO   0
 #endif
diff -ruN gcc-15.1.0.orig/gcc/common/config/rs6000/rs6000-common.cc gcc-15.1.0/gcc/common/config/rs6000/rs6000-common.cc
--- gcc-15.1.0.orig/gcc/common/config/rs6000/rs6000-common.cc	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/common/config/rs6000/rs6000-common.cc	2025-04-25 15:58:40.264619834 +0300
@@ -27,6 +27,11 @@
 #include "opts.h"
 #include "flags.h"
 
+#ifdef TARGET_USES_MORPHOS_OPT
+/* mclib */
+const char *morphos_mclib_name = (char *)0;
+#endif
+
 /* Implement TARGET_OPTION_OPTIMIZATION_TABLE.  */
 static const struct default_options rs6000_option_optimization_table[] =
   {
@@ -231,7 +236,13 @@
     case OPT_mrecip:
       opts->x_rs6000_recip_name = (value) ? "default" : "none";
       break;
-    }
+
+	#ifdef TARGET_USES_MORPHOS_OPT
+		case OPT_mclib_:
+		  morphos_mclib_name = arg;
+		  break;
+	#endif
+	}
   return true;
 }
 
diff -ruN gcc-15.1.0.orig/gcc/common.opt gcc-15.1.0/gcc/common.opt
--- gcc-15.1.0.orig/gcc/common.opt	2025-04-25 11:18:00.000000000 +0300
+++ gcc-15.1.0/gcc/common.opt	2025-04-25 15:58:40.264619834 +0300
@@ -1269,7 +1269,7 @@
 Looks for opportunities to reduce stack adjustments and stack references.
 
 fcommon
-Common Var(flag_no_common,0) Init(1)
+Common Var(flag_no_common,0)
 Put uninitialized globals in the common section.
 
 fcompare-debug
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/morphos.c gcc-15.1.0/gcc/config/rs6000/morphos.c
--- gcc-15.1.0.orig/gcc/config/rs6000/morphos.c	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/morphos.c	2025-04-25 15:58:40.264619834 +0300
@@ -0,0 +1,204 @@
+#include "config.h"
+#include "system.h"
+#include "coretypes.h"
+#include "tm.h"
+#include "rtl.h"
+#include "regs.h"
+#include "hard-reg-set.h"
+#include "insn-config.h"
+#include "conditions.h"
+#include "insn-flags.h"
+#include "output.h"
+#include "insn-attr.h"
+#include "flags.h"
+#include "hash-set.h"
+#include "machmode.h"
+#include "vec.h"
+#include "double-int.h"
+#include "input.h"
+#include "alias.h"
+#include "symtab.h"
+#include "wide-int.h"
+#include "inchash.h"
+#include "tree.h"
+#include "cgraph.h"
+#include "fold-const.h"
+#include "stringpool.h"
+#include "varasm.h"
+#include "stor-layout.h"
+#include "hashtab.h"
+#include "function.h"
+#include "statistics.h"
+#include "real.h"
+#include "fixed-value.h"
+#include "expmed.h"
+#include "dojump.h"
+#include "explow.h"
+#include "calls.h"
+//#include "emit-rtl.h"
+#include "stmt.h"
+#include "expr.h"
+#include "reload.h"
+#include "ggc.h"
+#include "langhooks.h"
+#include "target.h"
+#include "tm_p.h"
+#include "diagnostic-core.h"
+#include "toplev.h"
+#include "dominance.h"
+#include "cfg.h"
+#include "cfgrtl.h"
+#include "bitmap.h"
+#include "cfganal.h"
+#include "lcm.h"
+#include "cfgbuild.h"
+#include "cfgcleanup.h"
+#include "predict.h"
+#include "basic-block.h"
+#include "df.h"
+#include "debug.h"
+#include "obstack.h"
+#include "hash-table.h"
+#include "tree-ssa-alias.h"
+#include "internal-fn.h"
+#include "tree-eh.h"
+#include "gimple-expr.h"
+#include "is-a.h"
+#include "gimple.h"
+#include "gimplify.h"
+#include "gimple-iterator.h"
+#include "gimple-fold.h"
+#include "hash-map.h"
+#include "plugin-api.h"
+#include "ipa-ref.h"
+#include "cgraph.h"
+#include "lto-streamer.h"
+#include "lto-section-names.h"
+#include "rtl-iter.h"
+//#include "c-tree.h"
+#include "attribs.h"
+
+/* mclib */
+//const char *morphos_mclib_name = (char *)0;
+
+#ifdef __MORPHOS__
+#define STACKSIZE 2097152
+#define str(s) #s
+#define sstr(s) str(s)
+asm("\n"
+"        .section \".rodata\"\n"
+"        .align  2\n"
+"        .globl  __stack\n"
+"        .ascii  \"StCk\"\n"        /* Magic cookie */
+"__stack:\n"
+"        .long   " sstr(STACKSIZE) "\n"
+"        .ascii  \"sTcK\"\n"        /* Magic cookie */
+"        .section \".text\"\n"
+"        .align  2\n"
+);
+#endif
+
+/* mbaserel32 */
+rtx morphos_legitimize_baserel_address(rtx addr)
+{
+	rtx dest = gen_reg_rtx (Pmode);
+    
+	emit_insn (gen_elf_base_high (dest, gen_rtx_REG (Pmode, 13), addr));
+	emit_insn (gen_elf_base_low (dest, dest, addr));
+
+	return dest;
+}
+
+rtx morphos_legitimize_baserel_address_in_place(rtx addr, rtx dest)
+{
+	emit_insn (gen_elf_base_high (dest, gen_rtx_REG (Pmode, 13), addr));
+	emit_insn (gen_elf_base_low (dest, dest, addr));
+
+	return dest;
+}
+
+bool morphos_baserel_operand(rtx x)
+{
+   if (TARGET_BASEREL)
+	{
+		if (GET_CODE(x) == SYMBOL_REF)
+			return SYMBOL_REF_MORPHOS_BASEREL_P(x);
+		else if (GET_CODE(x) == CONST
+					&& GET_CODE(XEXP(x, 0)) == PLUS
+					&& GET_CODE(XEXP(XEXP(x, 0), 0)) == SYMBOL_REF
+					&& GET_CODE(XEXP(XEXP(x, 0), 1)) == CONST_INT)
+						return morphos_baserel_operand(XEXP(XEXP(x, 0), 0));
+		else if (GET_CODE(x) == LO_SUM)
+						return morphos_baserel_operand(XEXP(x, 1));
+	}
+
+	return false;
+}
+
+
+#if 0
+static int
+morphos_baserel_symbol_ref_1 (rtx *x, void *data ATTRIBUTE_UNUSED)
+{
+  return SYMBOL_REF_MORPHOS_BASEREL_P (*x);
+}
+
+
+bool morphos_baserel_referenced_p (rtx x)
+{
+  if (!TARGET_BASEREL)
+    return false;
+
+  return for_each_rtx (&x, &morphos_baserel_symbol_ref_1, 0);
+}
+#else
+bool morphos_baserel_referenced_p (rtx x)
+{
+	subrtx_iterator::array_type array;
+
+	if (!TARGET_BASEREL)
+	  return false;
+
+	FOR_EACH_SUBRTX (iter, array, x, NONCONST /* <= not sure about this one */)
+	{
+		if (SYMBOL_REF_MORPHOS_BASEREL_P(*iter))
+			return true;
+	}
+ 
+	return false;
+}
+#endif
+
+tree morphos_handle_saveds_attribute(tree *node, tree name, tree args ATTRIBUTE_UNUSED, int flags ATTRIBUTE_UNUSED, bool *no_add_attrs)
+{
+	if (TREE_CODE (*node) != FUNCTION_TYPE
+		&& TREE_CODE (*node) != FIELD_DECL
+		&& TREE_CODE (*node) != TYPE_DECL)
+	{
+		warning (OPT_Wattributes, "%qE attribute only applies to functions", name);
+		*no_add_attrs = true;
+	}
+
+  return NULL_TREE;
+}
+
+bool morphos_use_anchors_for_symbol_p (const_rtx symbol)
+{
+	if (TARGET_BASEREL && SYMBOL_REF_MORPHOS_BASEREL_P(symbol))
+		return false;
+	else
+		return default_use_anchors_for_symbol_p (symbol);
+}
+
+const char *morphos_check_pch_target_flags (int old_flags)
+{
+	if ((old_flags ^ target_flags) & MASK_BASEREL)
+		return "created and used with different setting -mbaserel32";
+	return NULL;
+}
+
+void morphos_rs6000_override_options (void)
+{
+	if (rs6000_default_long_calls)
+		global_options.x_TARGET_SCHED_PROLOG = 0;
+}
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/morphos.h gcc-15.1.0/gcc/config/rs6000/morphos.h
--- gcc-15.1.0.orig/gcc/config/rs6000/morphos.h	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/morphos.h	2025-04-25 15:58:40.264619834 +0300
@@ -0,0 +1,322 @@
+#undef  MD_EXEC_PREFIX
+#undef  MD_STARTFILE_PREFIX
+
+#undef  PROCESSOR_DEFAULT
+#define PROCESSOR_DEFAULT PROCESSOR_PPC604e
+
+#undef  DEFAULT_ABI
+#define DEFAULT_ABI ABI_V4
+
+#undef  TARGET_DEFAULT
+#define TARGET_DEFAULT 0
+
+/* Put jump tables in .text to save some relocations */
+#undef  JUMP_TABLES_IN_TEXT_SECTION
+#define JUMP_TABLES_IN_TEXT_SECTION 1
+
+#undef EH_FRAME_THROUGH_COLLECT2
+#define EH_FRAME_THROUGH_COLLECT2 1
+
+/* We don't care about compatibility in this case as ABI from 2.95.x is not compatible anyway */
+#undef  DEFAULT_VTABLE_THUNKS
+#define DEFAULT_VTABLE_THUNKS 1
+
+/* Use same method of struct return as our 2.95.x */
+#undef  DEFAULT_PCC_STRUCT_RETURN
+#define DEFAULT_PCC_STRUCT_RETURN 1
+
+#undef DWARF2_DEBUGGING_INFO
+#define DWARF2_DEBUGGING_INFO 1
+
+#undef PREFERRED_DEBUGGING_TYPE
+#define PREFERRED_DEBUGGING_TYPE DWARF2_DEBUG
+
+#undef DWARF2_UNWIND_INFO
+#define DWARF2_UNWIND_INFO 1
+
+#ifdef TARGET_BASEREL
+#undef USE_TM_CLONE_REGISTRY
+#define USE_TM_CLONE_REGISTRY 0
+#endif
+
+#undef  WCHAR_TYPE
+#define WCHAR_TYPE "int"
+
+#undef  WCHAR_TYPE_SIZE
+#define WCHAR_TYPE_SIZE 32
+
+
+#define IS_MCLIB(__MCL__) \
+  (strcmp(morphos_mclib_name, __MCL__) == 0)
+
+#undef TARGET_OS_CPP_BUILTINS
+#define TARGET_OS_CPP_BUILTINS()                \
+  do                                            \
+    {                                           \
+      builtin_define_std ("__PPC__");           \
+      builtin_define_std ("__powerpc__");       \
+      builtin_define_std ("__MORPHOS__");       \
+      builtin_define_std ("__morphos__");       \
+      builtin_define_std ("AMIGA");             \
+      builtin_define_std ("_AMIGA");            \
+      builtin_define_std ("amigaos");           \
+      builtin_define_std ("__amigaos__");       \
+      builtin_assert ("cpu=powerpc");           \
+      builtin_assert ("machine=powerpc");       \
+      builtin_assert ("system=morphos");        \
+      if ( !morphos_mclib_name || IS_MCLIB("ixemul")) \
+        {                                       \
+          builtin_define_std ("ixemul");        \
+         builtin_define_std ("__ixemul");      \
+          builtin_define_std ("__ixemul__");    \
+        }                                       \
+      else if (IS_MCLIB("libnix"))              \
+        {                                       \
+          builtin_define_std ("libnix");        \
+          builtin_define_std ("__libnix");      \
+          builtin_define_std ("__libnix__");    \
+        }                                       \
+      else if (IS_MCLIB("newlib"))              \
+        {                                       \
+          builtin_define_std ("newlib");        \
+          builtin_define_std ("__newlib");      \
+         builtin_define_std ("__newlib__");    \
+        }                                       \
+     builtin_define ("__saveds=__attribute__((__saveds__))");    \
+      TARGET_OS_SYSV_CPP_BUILTINS ();           \
+    }                                           \
+  while (0)
+
+//void morphos_rs6000_override_options (void);
+//#undef SUBTARGET_OVERRIDE_OPTIONS
+//#define SUBTARGET_OVERRIDE_OPTIONS morphos_rs6000_override_options ()
+
+#undef  CPP_SPEC
+#define CPP_SPEC "%{posix: -D_POSIX_SOURCE} %{pthread: -D_REENTRANT} %(cpp_os_default)"
+
+#undef CC1_SPEC
+#define        CC1_SPEC "%{G*} %(cc1_cpu)" \
+"%{g: %{!fno-eliminate-unused-debug-symbols: -feliminate-unused-debug-symbols}} \
+%{g1: %{!fno-eliminate-unused-debug-symbols: -feliminate-unused-debug-symbols}} \
+%{msdata: -msdata=default} \
+%{mno-sdata: -msdata=none} \
+%{!mbss-plt: %{!msecure-plt: %(cc1_secure_plt_default)}} \
+%{profile: -p} \
+%{faltivec:-maltivec -include altivec.h} %{fno-altivec:-mno-altivec} \
+%<faltivec %<fno-altivec \
+%{vec:-maltivec -include altivec.h} %{fno-vec:-mno-altivec} \
+%<fvec %<fno-vec "
+
+#undef  NATIVE_SYSTEM_HEADER_DIR
+//#define NATIVE_SYSTEM_HEADER_DIR     "/include"
+
+#undef  LOCAL_INCLUDE_DIR
+#define LOCAL_INCLUDE_DIR        "/usr/include"
+
+#undef  OSINCLUDE_DIR
+#define OSINCLUDE_DIR       "/os-include"
+
+#define SUB3TARGET_OVERRIDE_OPTIONS  \
+do                                   \
+{                                    \
+  if (TARGET_ALTIVEC)                \
+  {                                  \
+    rs6000_altivec_abi = 1;          \
+    TARGET_ALTIVEC_VRSAVE = 1;       \
+  }                                  \
+  if (TARGET_RESIDENT)               \
+  {                                  \
+    target_flags |= MASK_BASEREL;    \
+  }                                  \
+} while(0)
+
+/* We can't use 'bl' from .init/.fini to .text, so use a trampoline. */
+#define CRT_CALL_STATIC_FUNCTION(SECTION_OP, FUNC) \
+static void __attribute__((__used__))              \
+call_ ## FUNC (void) {                             \
+  asm(SECTION_OP "\n"                              \
+      "lis 11," #FUNC "@ha\n"                      \
+      "addi 11,11," #FUNC "@l\n"                   \
+      "mtctr 11\n"                                 \
+      "bctrl\n"                                    \
+      TEXT_SECTION_ASM_OP); }
+
+#undef ASM_OUTPUT_ALIGNED_DECL_LOCAL
+#define        ASM_OUTPUT_ALIGNED_DECL_LOCAL(FILE, DECL, NAME, SIZE, ALIGN)    \
+do {                                                                   \
+  if ((TARGET_BASEREL) && (DECL) && TREE_READONLY (DECL)) \
+    { \
+      switch_to_section (readonly_data_section); \
+      ASM_OUTPUT_ALIGN (FILE, exact_log2 (ALIGN / BITS_PER_UNIT));     \
+      ASM_OUTPUT_LABEL (FILE, NAME);                                   \
+      ASM_OUTPUT_SKIP (FILE, SIZE);                                    \
+      if (!flag_inhibit_size_directive && (SIZE) > 0)                  \
+       ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);                   \
+    } \
+  else if ((DECL) && rs6000_elf_in_small_data_p (DECL))                        \
+    {                                                                  \
+      switch_to_section (sbss_section);                                        \
+      ASM_OUTPUT_ALIGN (FILE, exact_log2 (ALIGN / BITS_PER_UNIT));     \
+      ASM_OUTPUT_LABEL (FILE, NAME);                                   \
+      ASM_OUTPUT_SKIP (FILE, SIZE);                                    \
+      if (!flag_inhibit_size_directive && (SIZE) > 0)                  \
+       ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);                   \
+    }                                                                  \
+  else                                                                 \
+    {                                                                  \
+      fprintf (FILE, "%s", LCOMM_ASM_OP);                              \
+      assemble_name ((FILE), (NAME));                                  \
+      fprintf ((FILE), "," HOST_WIDE_INT_PRINT_UNSIGNED ",%u\n",         \
+              (SIZE), (ALIGN) / BITS_PER_UNIT);                        \
+    }                                                                  \
+  ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");                    \
+} while (0)
+
+#undef ASM_OUTPUT_ALIGNED_BSS
+#define ASM_OUTPUT_ALIGNED_BSS(FILE, DECL, NAME, SIZE, ALIGN)          \
+do {                                                                   \
+  ASM_OUTPUT_ALIGNED_DECL_LOCAL (FILE, DECL, NAME, SIZE, ALIGN);       \
+} while (0)
+
+#undef  ASM_OUTPUT_ALIGNED_DECL_COMMON
+#define ASM_OUTPUT_ALIGNED_DECL_COMMON(FILE, DECL, NAME, SIZE, ALIGN)          \
+  do                                                                   \
+    {                                                                  \
+      if((TARGET_BASEREL) && (DECL) && TREE_READONLY (DECL)) \
+        fprintf ((FILE), "%s", READONLY_DATA_SECTION_ASM_OP );                         \
+      else \
+        fprintf ((FILE), "%s", COMMON_ASM_OP);                         \
+      assemble_name ((FILE), (NAME));                                  \
+      fprintf ((FILE), "," HOST_WIDE_INT_PRINT_UNSIGNED ",%u\n",         \
+              (SIZE), (ALIGN) / BITS_PER_UNIT);                        \
+    }                                                                  \
+  while (0)
+
+/* C library */
+#define CPP_MORPHOS_DEFAULT_SPEC       "%{mclib=default|!mclib=*:%<mclib=default -mclib=ixemul} %(cpp_ixemul)"
+#define LINK_MORPHOS_DEFAULT_SPEC      "%(link_ixemul)"
+#define STARTFILE_MORPHOS_DEFAULT_SPEC "%(startfile_ixemul)"
+#define ENDFILE_MORPHOS_DEFAULT_SPEC   "%(endfile_ixemul)"
+
+/* ... ixemul */
+#define CPP_IXEMUL_SPEC       "-idirafter /gg/include"
+#define LINK_IXEMUL_SPEC      "--flavor=ixemul"
+#define STARTFILE_IXEMUL_SPEC "%{mbaserel32:%{!mresident32:lcrt0i.o%s}} %{mresident32:scrt0i.o%s} %{!mresident32:%{!mbaserel32:crt0i.o%s}} ecrti.o%s crtbegin.o%s"
+#define ENDFILE_IXEMUL_SPEC   "crtend.o%s ecrtn.o%s"
+
+/* ... libnix */
+#define CPP_LIBNIX_SPEC       "-idirafter /gg/includestd -idirafter /gg/include"
+#define LINK_LIBNIX_SPEC      "--flavor=libnix"
+#define STARTFILE_LIBNIX_SPEC "%{mbaserel32:%{!mresident32:libnix/lcrt0i.o%s}} %{mresident32:libnix/scrt0i.o%s} %{!mresident32:%{!mbaserel32:libnix/crt0i.o%s}} ecrti.o%s crtbegin.o%s"
+#define ENDFILE_LIBNIX_SPEC   "crtend.o%s ecrtn.o%s"
+
+/* ... newlib */
+#define CPP_NEWLIB_SPEC       "-isystem /gg/include-newlib -isystem /gg/includenl -isystem /gg/usr/include-newlib"
+#define LINK_NEWLIB_SPEC      "--flavor=newlib"
+#define STARTFILE_NEWLIB_SPEC "%{mbaserel32:%{!mresident32:newlib/lcrt0i.o%s}} %{mresident32:newlib/scrt0i.o%s} %{!mresident32:%{!mbaserel32:newlib/crt0i.o%s}} ecrti.o%s crtbegin.o%s"
+#define ENDFILE_NEWLIB_SPEC   "crtend.o%s ecrtn.o%s"
+
+/* ... general */
+#undef  CPP_OS_DEFAULT_SPEC
+#define CPP_OS_DEFAULT_SPEC " \
+%{mbaserel32: %{msdata|msdata=default|msdata=sysv: %e-mbaserel32 and -msdata are not compatible}} \
+%{mclib=ixemul: %(cpp_ixemul); \
+mclib=libnix: %(cpp_libnix); \
+mclib=newlib: %(cpp_newlib); \
+mclib=default|!mclib=*: %{mclib=default|!nostdinc: %(cpp_morphos_default)}; \
+: %eInvalid mclib}"
+
+
+#undef LINK_SPEC
+#define LINK_SPEC "\
+--defsym __abox__=1 -Bstatic \
+%{h*} %{v:-V} %{G*} \
+%{Wl,*:%*} %{YP,*} %{R*} \
+%{Qy:} %{!Qn:-Qy} \
+%{mbaserel32: %{msdata|msdata=default|msdata=sysv: %e-mbaserel32 and -msdata are not compatible}} \
+%{mbaserel32: %{!mresident32:-m morphos_baserel --flavor=libb32}} %{mresident32:-m morphos_baserel --datadata-reloc --flavor=libb32} \
+%{mclib=ixemul: %(link_ixemul); \
+mclib=libnix: %(link_libnix); \
+mclib=newlib: %(link_newlib); \
+mclib=default|!mclib=*: %(link_morphos_default); \
+: %eInvalid mclib}"
+
+#undef STARTFILE_SPEC
+#define STARTFILE_SPEC "\
+%{mclib=ixemul: %(startfile_ixemul); \
+mclib=libnix: %(startfile_libnix); \
+mclib=newlib: %(startfile_newlib); \
+mclib=default|!mclib=*: %(startfile_morphos_default); \
+: %eInvalid mclib}"
+
+#undef ENDFILE_SPEC
+#define ENDFILE_SPEC "\
+%{mclib=ixemul: %(endfile_ixemul); \
+mclib=libnix: %(endfile_libnix); \
+mclib=newlib: %(endfile_newlib); \
+mclib=default|!mclib=*: %(endfile_morphos_default); \
+: %eInvalid mclib}"
+
+
+#undef LIB_SPEC
+#define LIB_SPEC "%{!nostdlib: -L/gg/lib -L/gg/usr/lib} --start-group -lc -labox -laboxstubs -lsavl -latomic %{mclib=libnix: -lauto} %{pthread:-lpthread} --end-group"
+
+#undef SUBTARGET_EXTRA_SPECS
+#define SUBTARGET_EXTRA_SPECS \
+  {"cpp_os_default", CPP_OS_DEFAULT_SPEC}, \
+  /* default C runtime */ \
+  {"cpp_morphos_default", CPP_MORPHOS_DEFAULT_SPEC}, \
+  {"link_morphos_default", LINK_MORPHOS_DEFAULT_SPEC}, \
+  {"startfile_morphos_default", STARTFILE_MORPHOS_DEFAULT_SPEC}, \
+  {"endfile_morphos_default", ENDFILE_MORPHOS_DEFAULT_SPEC}, \
+  /* ixemul */ \
+  {"cpp_ixemul", CPP_IXEMUL_SPEC}, \
+  {"link_ixemul", LINK_IXEMUL_SPEC}, \
+  {"startfile_ixemul", STARTFILE_IXEMUL_SPEC}, \
+  {"endfile_ixemul", ENDFILE_IXEMUL_SPEC}, \
+  /* libnix */ \
+  {"cpp_libnix", CPP_LIBNIX_SPEC}, \
+  {"link_libnix", LINK_LIBNIX_SPEC}, \
+  {"startfile_libnix", STARTFILE_LIBNIX_SPEC}, \
+  {"endfile_libnix", ENDFILE_LIBNIX_SPEC}, \
+  /* newlib */ \
+  {"cpp_newlib", CPP_NEWLIB_SPEC}, \
+  {"link_newlib", LINK_NEWLIB_SPEC}, \
+  {"startfile_newlib", STARTFILE_NEWLIB_SPEC}, \
+  {"endfile_newlib", ENDFILE_NEWLIB_SPEC},
+
+/* MorphOS specific attributes */
+#if 1
+#define SUBTARGET_ATTRIBUTE_TABLE \
+  { "saveds", 0, 0, false, true, true, false, morphos_handle_saveds_attribute, NULL }
+
+
+/* Data-Data reloc name */
+#define DATA_DATA_RELOC "drel"
+
+/* MorphOS symbol-ref flags */
+#define SYMBOL_FLAG_MORPHOS_BASEREL (SYMBOL_FLAG_MACH_DEP << 0)
+#define SYMBOL_REF_MORPHOS_BASEREL_P(RTX) \
+  (GET_CODE (RTX) == SYMBOL_REF && ((SYMBOL_REF_FLAGS (RTX) & SYMBOL_FLAG_MORPHOS_BASEREL) != 0))
+
+
+/* Do not try to mix normal/baserel32 pch files */
+#undef TARGET_CHECK_PCH_TARGET_FLAGS
+#define TARGET_CHECK_PCH_TARGET_FLAGS morphos_check_pch_target_flags
+
+/* Do not use anchors for brel ref objects */
+#undef TARGET_USE_ANCHORS_FOR_SYMBOL_P
+#define TARGET_USE_ANCHORS_FOR_SYMBOL_P morphos_use_anchors_for_symbol_p
+#endif
+
+/* We always use gas */
+#undef TARGET_GAS
+#define TARGET_GAS 1
+
+/* Override TLS support to false */
+#undef HAVE_AS_TLS
+#define HAVE_AS_TLS 0
+
+/* Use morphos.opt */
+extern const char *morphos_mclib_name;
+#define TARGET_USES_MORPHOS_OPT 1
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/morphos.opt gcc-15.1.0/gcc/config/rs6000/morphos.opt
--- gcc-15.1.0.orig/gcc/config/rs6000/morphos.opt	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/morphos.opt	2025-04-25 15:58:40.264619834 +0300
@@ -0,0 +1,28 @@
+;
+
+mclib=
+Target RejectNegative Joined
+Select C library to use
+
+mbaserel32
+Target RejectNegative Mask(BASEREL)
+Generate 32-bits relative data access
+
+mresident32
+Target Var(TARGET_RESIDENT)
+Generate reentrant executable
+
+noixemul
+Target RejectNegative Alias(mclib=, libnix)
+
+faltivec
+Driver
+
+fvec
+Driver
+
+Waltivec-long-deprecated
+Driver Alias(mwarn-altivec-long)
+
+pthread
+Driver
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/morphos-protos.h gcc-15.1.0/gcc/config/rs6000/morphos-protos.h
--- gcc-15.1.0.orig/gcc/config/rs6000/morphos-protos.h	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/morphos-protos.h	2025-04-25 15:58:40.264619834 +0300
@@ -0,0 +1,21 @@
+#ifndef GCC_MORPHOS_PROTOS_H
+#define GCC_MORPHOS_PROTOS_H
+
+extern const char *morphos_check_pch_target_flags (int old_flags);
+
+#ifdef RTX_CODE
+
+extern rtx morphos_legitimize_baserel_address(rtx);
+extern rtx morphos_legitimize_baserel_address_in_place(rtx, rtx);
+extern bool morphos_baserel_operand(rtx);
+extern bool morphos_baserel_referenced_p (rtx);
+extern bool morphos_use_anchors_for_symbol_p (const_rtx);
+
+#ifdef TREE_CODE
+extern int morphos_not_baserel_tree_p(tree);
+extern tree morphos_handle_saveds_attribute (tree *, tree, tree, int, bool*);
+#endif /* TREE_CODE */
+
+#endif /* RTX_CODE */
+
+#endif /* GCC_MORPHOS_PROTOS_H */
diff -ruN gcc-15.1.0.orig/gcc/config/rs6000/morphos-stdint.h gcc-15.1.0/gcc/config/rs6000/morphos-stdint.h
--- gcc-15.1.0.orig/gcc/config/rs6000/morphos-stdint.h	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/gcc/config/rs6000/morphos-stdint.h	2025-04-25 15:58:40.264619834 +0300
@@ -0,0 +1,51 @@
+/* Definitions for <stdint.h> types on systems using AIX.
+   Copyright (C) 2009-2018 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#define SIG_ATOMIC_TYPE "int"
+
+#define INT8_TYPE "signed char"
+#define INT16_TYPE "short int"
+#define INT32_TYPE "int"
+#define INT64_TYPE (LONG_TYPE_SIZE == 64 ? "long int" : "long long int")
+#define UINT8_TYPE "unsigned char"
+#define UINT16_TYPE "short unsigned int"
+#define UINT32_TYPE "unsigned int"
+#define UINT64_TYPE (LONG_TYPE_SIZE == 64 ? "long unsigned int" : "long long unsigned int")
+
+#define INT_LEAST8_TYPE "signed char"
+#define INT_LEAST16_TYPE "short int"
+#define INT_LEAST32_TYPE "int"
+#define INT_LEAST64_TYPE (LONG_TYPE_SIZE == 64 ? "long int" : "long long int")
+#define UINT_LEAST8_TYPE "unsigned char"
+#define UINT_LEAST16_TYPE "short unsigned int"
+#define UINT_LEAST32_TYPE "unsigned int"
+#define UINT_LEAST64_TYPE (LONG_TYPE_SIZE == 64 ? "long unsigned int" : "long long unsigned int")
+
+#define INT_FAST8_TYPE "signed char"
+#define INT_FAST16_TYPE "short int"
+#define INT_FAST32_TYPE "int"
+#define INT_FAST64_TYPE (LONG_TYPE_SIZE == 64 ? "long int" : "long long int")
+#define UINT_FAST8_TYPE "unsigned char"
+#define UINT_FAST16_TYPE "short unsigned int"
+#define UINT_FAST32_TYPE "unsigned int"
+#define UINT_FAST64_TYPE (LONG_TYPE_SIZE == 64 ? "long unsigned int" : "long long unsigned int")
+
+#define INTPTR_TYPE "long int"
+#define UINTPTR_TYPE "long unsigned int"
+
